#!/usr/bin/perl

use Socket;

$port = 2410;
$sockaddr = 'S n a4 x8';
$dev = "/dev/ttyS0";
$baud = "2400";


sub sendCommand {
  my $str = join('',@_);
  print "WRITING: $str to serial port\n";
  print SERPORT "$str";
}

system ("stty -crtscts -ixon $baud < $dev");
open (SERPORT,">$dev");
select (SERPORT); $| = 1; select(stdout);

($name, $aliases, $proto) = getprotobyname('tcp');
($name, $aliases, $port) = getservbyname($port, 'tcp') unless $port =~ /^\d+$/;
$this = pack($sockaddr, AF_INET, $port, "\0\0\0\0");
select(NS); $| = 1; select(stdout);
select(FULLS); $| = 1; select(stdout);
socket(S, PF_INET, SOCK_STREAM, $proto) || die "socket: $!";
setsockopt(S, SOL_SOCKET, SO_REUSEADDR, pack("l",1));
bind(S, $this) || die "bind: $!";    
listen(S, 5) || die "connect: $!";
select(S); $| = 1; select(stdout);

$rin = '';
vec($rin,fileno(S),1) =1;

$done =0;
$inuse=0;
while (!$done) {
  select ($rout=$rin,$wout=$rin,$eout=$rin,undef);
  if (vec($rout,fileno(S),1)) {
    	
	if ($inuse) {
	  print "Refusing Connection..\n";
	  ($addr = accept(FULLS,S)) || next;
	  print FULLS "IN USE\n";
	  close (FULLS);
	} else {
	  print "Got Connection..\n";
	  ($addr = accept(NS,S)) || next;
	  vec($rin,fileno(NS),1)=1;
	  $inuse = 1;
	  print NS "You're in control\n";
	}
  }
  if (vec($eout,fileno(NS),1)) {
  }
  if (vec($rout,fileno(NS),1)) {
    $line = <NS>;
	if ($line eq "") {
      print "Client Dropped..\n";
      vec($rin,fileno(NS),1)=0;
  	  close (NS);
	  $inuse=0;
	  next;
	}
	chop $line;
    print "GOT: $line\n";
	if ($line =~ /^R/) {sendCommand("A");next;}
	if ($line eq "P:F") {sendCommand("I");}
	if ($line eq "P:FR") {sendCommand("KI");}
	if ($line eq "P:FL") {sendCommand("JI");}
	if ($line eq "P:S") {sendCommand("A");}
	if ($line eq "P:B") {sendCommand("M");}
	if ($line eq "P:BR") {sendCommand("KM");}
	if ($line eq "P:BL") {sendCommand("JM");}
  }
}
